/*************************************************************************************
*   Un enregistreur de donnees GPS . Date Heure Latiude et Longitude sur une carte SD*
*dont l'inteval des enregistrements n'est valide que si il y a eu mouvement afin de  *
*ne pas emplir la carte SD inutilement. Retrouver toutes les information les détails *
* de realisation sur mon site  :  https://www.amazing-vacuum-tubes.com/pages/pour-y- *
*arriver/un-enregistreur-de-positions-gps.html (une seule ligne sans espace)         *
*************************************************************************************/

#include <SPI.h>
#include <SD.h>
#include <TinyGPS++.h>
#include <SoftwareSerial.h>
#include <avr/pgmspace.h>

static const int RXPin = 3, TXPin = 2; //GPS communication croisée
static  const uint32_t GPSBaud = 9600; // vitesse de communication GPS
const int cs_sd=10; // Pin de validation de l'acces a la carte SD

TinyGPSPlus  gps;
SoftwareSerial ss(RXPin, TXPin);

int recLed = 8; // Led de visualisation d'enregistrement sur carte

String lat, lon;   //Latitude, Longitude
String old_lat, old_lon;   //précédentes Latitude, Longitude
String  Date, Temps; // Horodatage 


void setup()
{
  Serial.begin(9600); // Vitesse de communication GPS
  ss.begin(GPSBaud);

  pinMode(recLed, OUTPUT); // DDR de la Led => en sortie

  if(!SD.begin(cs_sd))    // La carte SD est prsente ?
  {
    return;
  }

  delay(1000);
  
  File data = SD.open("datas.txt",FILE_WRITE);              // Cree & Ouvre le  fichier "datas.txt"
  data.println(""); data.println("Deb. enregistr.");    // Ecrit dans le fichier
  digitalWrite (recLed, HIGH);  //Allume la Led
  data.close(); // Ferme le fichier
  delay(1000);
  digitalWrite (recLed, LOW); //Eteind la Led
}

void  loop()
{
  while (ss.available()  > 0){ // Tant que bonne reception satellite
    gps.encode(ss.read());  // lecture des infos
    if (gps.location.isUpdated()){  // Si infos disponnibles...
      Date=String(gps.date.day())+(" ")+(gps.date.month())+(" ")+(gps.date.year()); // recuperation date
       Temps=String(gps.time.hour()+1)+(" ")+(gps.time.minute())+("  ")+(gps.time.second());  // recuperation heure
        lat=String(gps.location.lat(), 4); // recuperation latitude (a 4 chiffres aprèe la virgule)
         lon=String(gps.location.lng(), 4);  // recuperation longitude (a 4 chiffres aprèe la virgule)

  smartDelay(400); // delai entre deux receptions (a regler suivant besoin & économie de batterie)

  // Ecriture des donnes dans le fichier texte
  if ((lat!=old_lat) or (lon!=old_lon)) {  // Si une difference de position est comparee entre la precedente et la nouvelle
    File data=SD.open("datas.txt",FILE_WRITE);  //Ouvre le  fichier "datas.txt"
      data.println(Date + "   " + Temps + "    " + String(gps.location.lat(), 6)+"   "+String(gps.location.lng(), 6)+(" ")); //ecrit tout ça sur la carte
        digitalWrite (recLed, HIGH);  //Allume la Led
          data.close();  // Ferme le fichier
            delay(1000);
        old_lat  = lat; // MàJ de l'ancienne latitude
     old_lon  = lon;  // MàJ de l'ancienne longitude
  digitalWrite (recLed, LOW); //Allume la Led
  }
}
  }
}
// delai entre deux receptions
static void smartDelay(unsigned long ms)
{
  unsigned  long start = millis();
  do
  {
    while (ss.available())
      gps.encode(ss.read());
  } while (millis() - start < ms);
}



